
// Step 1. Import the video library
import processing.video.*;
// Step 2. Declare a Capture object
Capture video;
Ball ball1;
Ball ball2;
Ball ball3;
color trackColor;


void setup() {
size(400,400);
video = new Capture(this,width,height,15);
trackColor = color(255,0,0);
smooth();
ball1 = new Ball(32);
ball2 = new Ball(32);
ball3 =  new Ball(32);
}
void draw() {
  
  background(255);
  if(video.available()){
    video.read();
  }
  video.loadPixels();
image(video,0,0);
  // Closest record, we start with a high number
float worldRecord = 500;
// XY coordinate of closest color
int closestX = 0;
int closestY = 0;
// Begin loop to walk through every pixel
for (int x = 0; x < video.width; x ++ ) {
for (int y = 0; y < video.height; y ++ ) {
int loc = x + y*video.width;
// What is current color
color currentColor = video.pixels[loc];
float r1 = red(currentColor);
float g1 = green(currentColor);
float b1 = blue(currentColor);
float r2 = red(trackColor);
float g2 = green(trackColor);
float b2 = blue(trackColor);
// Using euclidean distance to compare colors
float d = dist(r1,g1,b1,r2,g2,b2);
// If current color is more similar to tracked color than
// closest color, save current location and current difference
if (d < worldRecord) {
worldRecord = d;
closestX = x;
closestY = y;
}
}
}
if (worldRecord < 10) {
// Draw a circle at the tracked pixel
fill(trackColor);
strokeWeight(4.0);
stroke(0);
ellipse(closestX,closestY,16,16);
}
ball1.move();
ball3.move();
ball2.setLocation(closestX,closestY);
if (ball1.intersect(ball2)) {
}
else if(ball3.intersect(ball2)){
}
ball1.display();
ball2.display();
ball3.display();

}
class Ball {
float r; // radius
float x,y;
float xspeed,yspeed;
color c = color(100,50);
// Constructor
Ball(float tempR) {
r = tempR;
x = random(width);
y = random(height);
xspeed = random( -5,5);
yspeed = random( -5,5);
}
void move() {
x += xspeed; // Increment x
y += yspeed; // Increment y
// Check horizontal edges
if (x > width-r || x < 0) {
xspeed *= -1;
}
// Check vertical edges
if (y > height-r || y < 0) {
yspeed *= -1;
}
}

void setLocation(float tempX, float tempY) {
x = tempX;
y = tempY;
}
// Draw the ball
void display() {
stroke(0);
fill(c);
ellipse(x,y,r*2,r*2);
c = color(100,50);
}
boolean intersect(Ball b) {
float distance = dist(x,y,b.x,b.y); 
if (distance < r + b.r)
{ 
xspeed *= -1;
yspeed *= -1;
return true;
} else {
return false;
}
}
}

void els()
{

}

void mousePressed() {
// Save color where the mouse is clicked in trackColor variable
int loc = mouseX + mouseY*video.width;
trackColor = video.pixels[loc];
}
